import numpy as np
import matplotlib.pyplot as plt
import sys

'''
This script parse:
 - the `.gnu` file generated by bands.x
 - the `.projwfc` file generated by proj.x
and combine them into a series of files (for each orbital) for plotting.

Usage:

python parse.py test.gnu test.projwfc
'''

#%% load proj.x file
proj_filename = sys.argv[2]
# proj_filename='YCl-proj.dat.projwfc_up'
with open(proj_filename,'r') as f:
    proj_data = f.readlines()

nat    = int(proj_data[1].strip().split()[-2])
ntyp   = int(proj_data[1].strip().split()[-1])
natwfc = int(proj_data[4+nat+ntyp].strip().split()[0])
nkpt   = int(proj_data[4+nat+ntyp].strip().split()[1])
nbnd   = int(proj_data[4+nat+ntyp].strip().split()[2])
data_begin_line = 6+nat+ntyp

proj = {}
line_indx = data_begin_line; i = 1
while line_indx<len(proj_data[data_begin_line:]):
    # print(line_indx)
    label = '-'.join(np.array(proj_data[line_indx].strip().split())[[1,2,3]])
    proj[label] = np.array([itmp.strip().split() for itmp in proj_data[line_indx+1:line_indx+1+nkpt*nbnd]], dtype=float)
    line_indx = data_begin_line + i*(nkpt*nbnd+1)
    i+=1

#%% load bands.x file
band_filename = sys.argv[1]
a=np.loadtxt(band_filename)
# a=np.loadtxt('up.dat.gnu')
data = a.reshape([nbnd,nkpt,2])

#%%
data = np.swapaxes(data,0,1)
for key in proj.keys():
    data_tmp = proj[key].reshape(nkpt,nbnd,3)
    output = np.dstack((data,data_tmp[:,:,2]))
    output = np.swapaxes(output,0,1)
    np.savetxt(f'{key}.dat', output.reshape([-1,3]), fmt='%1.4e',header=f'  k_path      energy     weight | total # kpt {nkpt} | total # bnd {nbnd}')
    # np.savetxt(f'{key}.dat', output, fmt='%1.4e',header=f' kpt_idx    bnd_idx     weight | total # kpt {nkpt} | total # bnd {nbnd}')
    # with open(f'{key}.dat',w) as f:
    #     f.writeproj[key]
#%% plot?
# fig, ax = plt.subplots()
# for ibnd in range(nbnd):
#     ax.plot(data[ibnd,:,0],data[ibnd,:,1], color='tab:blue')
#     data_tmp = proj['1-Y-5S'].reshape(nkpt,nbnd,3)
#     ax.scatter(data[ibnd,:,0],data[ibnd,:,1],s=30*data_tmp[:,ibnd,2],c='tab:red',zorder = 100)
#
# plt.show()
